/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This file was generated.
 *  with google-apis-code-generator 1.4.0 (build: 2013-06-20 19:08:55 UTC)
 *  on 2013-06-25 at 19:50:17 UTC 
 */

package com.google.api.services.coordinate;

import com.google.api.client.googleapis.GoogleUtils;
import com.google.api.client.googleapis.services.AbstractGoogleClientRequest;
import com.google.api.client.googleapis.services.GoogleClientRequestInitializer;
import com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient;
import com.google.api.client.http.HttpRequestInitializer;
import com.google.api.client.http.HttpTransport;
import com.google.api.client.json.JsonFactory;
import com.google.api.client.json.JsonObjectParser;
import com.google.api.client.json.JsonString;
import com.google.common.base.Preconditions;
import com.google.common.primitives.UnsignedLong;

/**
 * Service definition for Coordinate (v1).
 *
 * <p>
 * Lets you view and manage jobs in a Coordinate team.
 * </p>
 *
 * <p>
 * For more information about this service, see the
 * <a href="https://developers.google.com/coordinate/" target="_blank">API Documentation</a>
 * </p>
 *
 * <p>
 * This service uses {@link CoordinateRequestInitializer} to initialize global parameters via its
 * {@link Builder}.
 * </p>
 *
 * <p>
 * Upgrade warning: this class now extends {@link AbstractGoogleJsonClient}, whereas in prior
 * version 1.8 it extended {@link com.google.api.client.googleapis.services.GoogleClient}.
 * </p>
 *
 * @since 1.3
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public class Coordinate extends AbstractGoogleJsonClient {

  // Note: Leave this static initializer at the top of the file.
  static {
    Preconditions.checkState(GoogleUtils.VERSION.equals("1.13.2-beta"),
        "You are currently running with version %s of google-api-client. " +
        "You need version 1.13.2-beta of google-api-client to run version " +
        "1.13.2-beta of the Google Maps Coordinate API library.", GoogleUtils.VERSION);
  }

  /**
   * The default encoded root URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_ROOT_URL = "https://www.googleapis.com/";

  /**
   * The default encoded service path of the service. This is determined when the library is
   * generated and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_SERVICE_PATH = "coordinate/v1/teams/";

  /**
   * The default encoded base URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   * @deprecated (scheduled to be removed in 1.13)
   */
  @Deprecated
  public static final String DEFAULT_BASE_URL = DEFAULT_ROOT_URL + DEFAULT_SERVICE_PATH;

  /**
   * Constructor.
   *
   * <p>
   * Use {@link Builder} if you need to specify any of the optional parameters.
   * </p>
   *
   * @param transport HTTP transport
   * @param jsonFactory JSON factory
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @since 1.7
   */
  public Coordinate(HttpTransport transport, JsonFactory jsonFactory,
      HttpRequestInitializer httpRequestInitializer) {
    super(transport,
        jsonFactory,
        DEFAULT_ROOT_URL,
        DEFAULT_SERVICE_PATH,
        httpRequestInitializer,
        false);
  }

  /**
   * @param transport HTTP transport
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @param rootUrl root URL of the service
   * @param servicePath service path
   * @param jsonObjectParser JSON object parser
   * @param googleClientRequestInitializer Google request initializer or {@code null} for none
   * @param applicationName application name to be sent in the User-Agent header of requests or
   *        {@code null} for none
   * @param suppressPatternChecks whether discovery pattern checks should be suppressed on required
   *        parameters
   */
  Coordinate(HttpTransport transport,
      HttpRequestInitializer httpRequestInitializer,
      String rootUrl,
      String servicePath,
      JsonObjectParser jsonObjectParser,
      GoogleClientRequestInitializer googleClientRequestInitializer,
      String applicationName,
      boolean suppressPatternChecks) {
    super(transport,
        httpRequestInitializer,
        rootUrl,
        servicePath,
        jsonObjectParser,
        googleClientRequestInitializer,
        applicationName,
        suppressPatternChecks);
  }

  @Override
  protected void initialize(AbstractGoogleClientRequest<?> httpClientRequest) throws java.io.IOException {
    super.initialize(httpClientRequest);
  }

  /**
   * An accessor for creating requests from the CustomFieldDef collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Coordinate coordinate = new Coordinate(...);}
   *   {@code Coordinate.CustomFieldDef.List request = coordinate.customFieldDef().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CustomFieldDef customFieldDef() {
    return new CustomFieldDef();
  }

  /**
   * The "customFieldDef" collection of methods.
   */
  public class CustomFieldDef {

    /**
     * Retrieves a list of custom field definitions for a team.
     *
     * Create a request for the method "customFieldDef.list".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @return the request
     */
    public List list(String teamId) throws java.io.IOException {
      List result = new List(teamId);
      initialize(result);
      return result;
    }

    public class List extends CoordinateRequest<com.google.api.services.coordinate.model.CustomFieldDefListResponse> {

      private static final String REST_PATH = "{teamId}/custom_fields";

      /**
       * Retrieves a list of custom field definitions for a team.
       *
       * Create a request for the method "customFieldDef.list".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link List#execute()} method to invoke the remote operation. <p>
       * {@link List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @since 1.13
       */
      protected List(String teamId) {
        super(Coordinate.this, "GET", REST_PATH, null, com.google.api.services.coordinate.model.CustomFieldDefListResponse.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public List setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Jobs collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Coordinate coordinate = new Coordinate(...);}
   *   {@code Coordinate.Jobs.List request = coordinate.jobs().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Jobs jobs() {
    return new Jobs();
  }

  /**
   * The "jobs" collection of methods.
   */
  public class Jobs {

    /**
     * Retrieves a job, including all the changes made to the job.
     *
     * Create a request for the method "jobs.get".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @param jobId Job number
     * @return the request
     */
    public Get get(String teamId, UnsignedLong jobId) throws java.io.IOException {
      Get result = new Get(teamId, jobId);
      initialize(result);
      return result;
    }

    public class Get extends CoordinateRequest<com.google.api.services.coordinate.model.Job> {

      private static final String REST_PATH = "{teamId}/jobs/{jobId}";

      /**
       * Retrieves a job, including all the changes made to the job.
       *
       * Create a request for the method "jobs.get".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link Get#execute()} method to invoke the remote operation. <p>
       * {@link Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @param jobId Job number
       * @since 1.13
       */
      protected Get(String teamId, UnsignedLong jobId) {
        super(Coordinate.this, "GET", REST_PATH, null, com.google.api.services.coordinate.model.Job.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
        this.jobId = Preconditions.checkNotNull(jobId, "Required parameter jobId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public Get setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

      /** Job number */
      @com.google.api.client.util.Key
      private UnsignedLong jobId;

      /** Job number
       */
      public UnsignedLong getJobId() {
        return jobId;
      }

      /** Job number */
      public Get setJobId(UnsignedLong jobId) {
        this.jobId = jobId;
        return this;
      }

    }
    /**
     * Inserts a new job. Only the state field of the job should be set.
     *
     * Create a request for the method "jobs.insert".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @param address Job address as newline (Unix) separated string
     * @param lat The latitude coordinate of this job's location.
     * @param lng The longitude coordinate of this job's location.
     * @param title Job title
     * @param content the {@link com.google.api.services.coordinate.model.Job}
     * @return the request
     */
    public Insert insert(String teamId, String address, Double lat, Double lng, String title, com.google.api.services.coordinate.model.Job content) throws java.io.IOException {
      Insert result = new Insert(teamId, address, lat, lng, title, content);
      initialize(result);
      return result;
    }

    public class Insert extends CoordinateRequest<com.google.api.services.coordinate.model.Job> {

      private static final String REST_PATH = "{teamId}/jobs";

      /**
       * Inserts a new job. Only the state field of the job should be set.
       *
       * Create a request for the method "jobs.insert".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link Insert#execute()} method to invoke the remote operation.
       * <p> {@link Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this
       * instance immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @param address Job address as newline (Unix) separated string
       * @param lat The latitude coordinate of this job's location.
       * @param lng The longitude coordinate of this job's location.
       * @param title Job title
       * @param content the {@link com.google.api.services.coordinate.model.Job}
       * @since 1.13
       */
      protected Insert(String teamId, String address, Double lat, Double lng, String title, com.google.api.services.coordinate.model.Job content) {
        super(Coordinate.this, "POST", REST_PATH, content, com.google.api.services.coordinate.model.Job.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
        this.address = Preconditions.checkNotNull(address, "Required parameter address must be specified.");
        this.lat = Preconditions.checkNotNull(lat, "Required parameter lat must be specified.");
        this.lng = Preconditions.checkNotNull(lng, "Required parameter lng must be specified.");
        this.title = Preconditions.checkNotNull(title, "Required parameter title must be specified.");
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public Insert setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

      /** Job address as newline (Unix) separated string */
      @com.google.api.client.util.Key
      private String address;

      /** Job address as newline (Unix) separated string
       */
      public String getAddress() {
        return address;
      }

      /** Job address as newline (Unix) separated string */
      public Insert setAddress(String address) {
        this.address = address;
        return this;
      }

      /** The latitude coordinate of this job's location. */
      @com.google.api.client.util.Key
      private Double lat;

      /** The latitude coordinate of this job's location.
       */
      public Double getLat() {
        return lat;
      }

      /** The latitude coordinate of this job's location. */
      public Insert setLat(Double lat) {
        this.lat = lat;
        return this;
      }

      /** The longitude coordinate of this job's location. */
      @com.google.api.client.util.Key
      private Double lng;

      /** The longitude coordinate of this job's location.
       */
      public Double getLng() {
        return lng;
      }

      /** The longitude coordinate of this job's location. */
      public Insert setLng(Double lng) {
        this.lng = lng;
        return this;
      }

      /** Job title */
      @com.google.api.client.util.Key
      private String title;

      /** Job title
       */
      public String getTitle() {
        return title;
      }

      /** Job title */
      public Insert setTitle(String title) {
        this.title = title;
        return this;
      }

      /** Customer name */
      @com.google.api.client.util.Key
      private String customerName;

      /** Customer name
       */
      public String getCustomerName() {
        return customerName;
      }

      /** Customer name */
      public Insert setCustomerName(String customerName) {
        this.customerName = customerName;
        return this;
      }

      /** Job note as newline (Unix) separated string */
      @com.google.api.client.util.Key
      private String note;

      /** Job note as newline (Unix) separated string
       */
      public String getNote() {
        return note;
      }

      /** Job note as newline (Unix) separated string */
      public Insert setNote(String note) {
        this.note = note;
        return this;
      }

      /** Assignee email address, or empty string to unassign. */
      @com.google.api.client.util.Key
      private String assignee;

      /** Assignee email address, or empty string to unassign.
       */
      public String getAssignee() {
        return assignee;
      }

      /** Assignee email address, or empty string to unassign. */
      public Insert setAssignee(String assignee) {
        this.assignee = assignee;
        return this;
      }

      /** Customer phone number */
      @com.google.api.client.util.Key
      private String customerPhoneNumber;

      /** Customer phone number
       */
      public String getCustomerPhoneNumber() {
        return customerPhoneNumber;
      }

      /** Customer phone number */
      public Insert setCustomerPhoneNumber(String customerPhoneNumber) {
        this.customerPhoneNumber = customerPhoneNumber;
        return this;
      }

      /**
     * Map from custom field id (from /team//custom_fields) to the field value. For example
     * '123=Alice'
     */
      @com.google.api.client.util.Key
      private java.util.List<String> customField;

      /** Map from custom field id (from /team//custom_fields) to the field value. For example '123=Alice'
       */
      public java.util.List<String> getCustomField() {
        return customField;
      }

      /**
     * Map from custom field id (from /team//custom_fields) to the field value. For example
     * '123=Alice'
     */
      public Insert setCustomField(java.util.List<String> customField) {
        this.customField = customField;
        return this;
      }

    }
    /**
     * Retrieves jobs created or modified since the given timestamp.
     *
     * Create a request for the method "jobs.list".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @return the request
     */
    public List list(String teamId) throws java.io.IOException {
      List result = new List(teamId);
      initialize(result);
      return result;
    }

    public class List extends CoordinateRequest<com.google.api.services.coordinate.model.JobListResponse> {

      private static final String REST_PATH = "{teamId}/jobs";

      /**
       * Retrieves jobs created or modified since the given timestamp.
       *
       * Create a request for the method "jobs.list".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link List#execute()} method to invoke the remote operation. <p>
       * {@link List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @since 1.13
       */
      protected List(String teamId) {
        super(Coordinate.this, "GET", REST_PATH, null, com.google.api.services.coordinate.model.JobListResponse.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public List setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

      /** Minimum time a job was modified in milliseconds since epoch. */
      @com.google.api.client.util.Key
      private UnsignedLong minModifiedTimestampMs;

      /** Minimum time a job was modified in milliseconds since epoch.
       */
      public UnsignedLong getMinModifiedTimestampMs() {
        return minModifiedTimestampMs;
      }

      /** Minimum time a job was modified in milliseconds since epoch. */
      public List setMinModifiedTimestampMs(UnsignedLong minModifiedTimestampMs) {
        this.minModifiedTimestampMs = minModifiedTimestampMs;
        return this;
      }

      /** Maximum number of results to return in one page. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** Maximum number of results to return in one page.
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** Maximum number of results to return in one page. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Continuation token */
      @com.google.api.client.util.Key
      private String pageToken;

      /** Continuation token
       */
      public String getPageToken() {
        return pageToken;
      }

      /** Continuation token */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

    }
    /**
     * Updates a job. Fields that are set in the job state will be updated. This method supports patch
     * semantics.
     *
     * Create a request for the method "jobs.patch".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link Patch#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @param jobId Job number
     * @param content the {@link com.google.api.services.coordinate.model.Job}
     * @return the request
     */
    public Patch patch(String teamId, UnsignedLong jobId, com.google.api.services.coordinate.model.Job content) throws java.io.IOException {
      Patch result = new Patch(teamId, jobId, content);
      initialize(result);
      return result;
    }

    public class Patch extends CoordinateRequest<com.google.api.services.coordinate.model.Job> {

      private static final String REST_PATH = "{teamId}/jobs/{jobId}";

      /**
       * Updates a job. Fields that are set in the job state will be updated. This method supports patch
       * semantics.
       *
       * Create a request for the method "jobs.patch".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link Patch#execute()} method to invoke the remote operation.
       * <p> {@link Patch#initialize(AbstractGoogleClientRequest)} must be called to initialize this
       * instance immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @param jobId Job number
       * @param content the {@link com.google.api.services.coordinate.model.Job}
       * @since 1.13
       */
      protected Patch(String teamId, UnsignedLong jobId, com.google.api.services.coordinate.model.Job content) {
        super(Coordinate.this, "PATCH", REST_PATH, content, com.google.api.services.coordinate.model.Job.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
        this.jobId = Preconditions.checkNotNull(jobId, "Required parameter jobId must be specified.");
      }

      @Override
      public Patch setAlt(String alt) {
        return (Patch) super.setAlt(alt);
      }

      @Override
      public Patch setFields(String fields) {
        return (Patch) super.setFields(fields);
      }

      @Override
      public Patch setKey(String key) {
        return (Patch) super.setKey(key);
      }

      @Override
      public Patch setOauthToken(String oauthToken) {
        return (Patch) super.setOauthToken(oauthToken);
      }

      @Override
      public Patch setPrettyPrint(Boolean prettyPrint) {
        return (Patch) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Patch setQuotaUser(String quotaUser) {
        return (Patch) super.setQuotaUser(quotaUser);
      }

      @Override
      public Patch setUserIp(String userIp) {
        return (Patch) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public Patch setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

      /** Job number */
      @com.google.api.client.util.Key
      private UnsignedLong jobId;

      /** Job number
       */
      public UnsignedLong getJobId() {
        return jobId;
      }

      /** Job number */
      public Patch setJobId(UnsignedLong jobId) {
        this.jobId = jobId;
        return this;
      }

      /** Customer name */
      @com.google.api.client.util.Key
      private String customerName;

      /** Customer name
       */
      public String getCustomerName() {
        return customerName;
      }

      /** Customer name */
      public Patch setCustomerName(String customerName) {
        this.customerName = customerName;
        return this;
      }

      /** Job title */
      @com.google.api.client.util.Key
      private String title;

      /** Job title
       */
      public String getTitle() {
        return title;
      }

      /** Job title */
      public Patch setTitle(String title) {
        this.title = title;
        return this;
      }

      /** Job note as newline (Unix) separated string */
      @com.google.api.client.util.Key
      private String note;

      /** Job note as newline (Unix) separated string
       */
      public String getNote() {
        return note;
      }

      /** Job note as newline (Unix) separated string */
      public Patch setNote(String note) {
        this.note = note;
        return this;
      }

      /** Assignee email address, or empty string to unassign. */
      @com.google.api.client.util.Key
      private String assignee;

      /** Assignee email address, or empty string to unassign.
       */
      public String getAssignee() {
        return assignee;
      }

      /** Assignee email address, or empty string to unassign. */
      public Patch setAssignee(String assignee) {
        this.assignee = assignee;
        return this;
      }

      /** Customer phone number */
      @com.google.api.client.util.Key
      private String customerPhoneNumber;

      /** Customer phone number
       */
      public String getCustomerPhoneNumber() {
        return customerPhoneNumber;
      }

      /** Customer phone number */
      public Patch setCustomerPhoneNumber(String customerPhoneNumber) {
        this.customerPhoneNumber = customerPhoneNumber;
        return this;
      }

      /** Job address as newline (Unix) separated string */
      @com.google.api.client.util.Key
      private String address;

      /** Job address as newline (Unix) separated string
       */
      public String getAddress() {
        return address;
      }

      /** Job address as newline (Unix) separated string */
      public Patch setAddress(String address) {
        this.address = address;
        return this;
      }

      /** The latitude coordinate of this job's location. */
      @com.google.api.client.util.Key
      private Double lat;

      /** The latitude coordinate of this job's location.
       */
      public Double getLat() {
        return lat;
      }

      /** The latitude coordinate of this job's location. */
      public Patch setLat(Double lat) {
        this.lat = lat;
        return this;
      }

      /** Job progress */
      @com.google.api.client.util.Key
      private String progress;

      /** Job progress
       */
      public String getProgress() {
        return progress;
      }

      /** Job progress */
      public Patch setProgress(String progress) {
        this.progress = progress;
        return this;
      }

      /** The longitude coordinate of this job's location. */
      @com.google.api.client.util.Key
      private Double lng;

      /** The longitude coordinate of this job's location.
       */
      public Double getLng() {
        return lng;
      }

      /** The longitude coordinate of this job's location. */
      public Patch setLng(Double lng) {
        this.lng = lng;
        return this;
      }

      /**
     * Map from custom field id (from /team//custom_fields) to the field value. For example
     * '123=Alice'
     */
      @com.google.api.client.util.Key
      private java.util.List<String> customField;

      /** Map from custom field id (from /team//custom_fields) to the field value. For example '123=Alice'
       */
      public java.util.List<String> getCustomField() {
        return customField;
      }

      /**
     * Map from custom field id (from /team//custom_fields) to the field value. For example
     * '123=Alice'
     */
      public Patch setCustomField(java.util.List<String> customField) {
        this.customField = customField;
        return this;
      }

    }
    /**
     * Updates a job. Fields that are set in the job state will be updated.
     *
     * Create a request for the method "jobs.update".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link Update#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @param jobId Job number
     * @param content the {@link com.google.api.services.coordinate.model.Job}
     * @return the request
     */
    public Update update(String teamId, UnsignedLong jobId, com.google.api.services.coordinate.model.Job content) throws java.io.IOException {
      Update result = new Update(teamId, jobId, content);
      initialize(result);
      return result;
    }

    public class Update extends CoordinateRequest<com.google.api.services.coordinate.model.Job> {

      private static final String REST_PATH = "{teamId}/jobs/{jobId}";

      /**
       * Updates a job. Fields that are set in the job state will be updated.
       *
       * Create a request for the method "jobs.update".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link Update#execute()} method to invoke the remote operation.
       * <p> {@link Update#initialize(AbstractGoogleClientRequest)} must be called to initialize this
       * instance immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @param jobId Job number
       * @param content the {@link com.google.api.services.coordinate.model.Job}
       * @since 1.13
       */
      protected Update(String teamId, UnsignedLong jobId, com.google.api.services.coordinate.model.Job content) {
        super(Coordinate.this, "PUT", REST_PATH, content, com.google.api.services.coordinate.model.Job.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
        this.jobId = Preconditions.checkNotNull(jobId, "Required parameter jobId must be specified.");
      }

      @Override
      public Update setAlt(String alt) {
        return (Update) super.setAlt(alt);
      }

      @Override
      public Update setFields(String fields) {
        return (Update) super.setFields(fields);
      }

      @Override
      public Update setKey(String key) {
        return (Update) super.setKey(key);
      }

      @Override
      public Update setOauthToken(String oauthToken) {
        return (Update) super.setOauthToken(oauthToken);
      }

      @Override
      public Update setPrettyPrint(Boolean prettyPrint) {
        return (Update) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Update setQuotaUser(String quotaUser) {
        return (Update) super.setQuotaUser(quotaUser);
      }

      @Override
      public Update setUserIp(String userIp) {
        return (Update) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public Update setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

      /** Job number */
      @com.google.api.client.util.Key
      private UnsignedLong jobId;

      /** Job number
       */
      public UnsignedLong getJobId() {
        return jobId;
      }

      /** Job number */
      public Update setJobId(UnsignedLong jobId) {
        this.jobId = jobId;
        return this;
      }

      /** Customer name */
      @com.google.api.client.util.Key
      private String customerName;

      /** Customer name
       */
      public String getCustomerName() {
        return customerName;
      }

      /** Customer name */
      public Update setCustomerName(String customerName) {
        this.customerName = customerName;
        return this;
      }

      /** Job title */
      @com.google.api.client.util.Key
      private String title;

      /** Job title
       */
      public String getTitle() {
        return title;
      }

      /** Job title */
      public Update setTitle(String title) {
        this.title = title;
        return this;
      }

      /** Job note as newline (Unix) separated string */
      @com.google.api.client.util.Key
      private String note;

      /** Job note as newline (Unix) separated string
       */
      public String getNote() {
        return note;
      }

      /** Job note as newline (Unix) separated string */
      public Update setNote(String note) {
        this.note = note;
        return this;
      }

      /** Assignee email address, or empty string to unassign. */
      @com.google.api.client.util.Key
      private String assignee;

      /** Assignee email address, or empty string to unassign.
       */
      public String getAssignee() {
        return assignee;
      }

      /** Assignee email address, or empty string to unassign. */
      public Update setAssignee(String assignee) {
        this.assignee = assignee;
        return this;
      }

      /** Customer phone number */
      @com.google.api.client.util.Key
      private String customerPhoneNumber;

      /** Customer phone number
       */
      public String getCustomerPhoneNumber() {
        return customerPhoneNumber;
      }

      /** Customer phone number */
      public Update setCustomerPhoneNumber(String customerPhoneNumber) {
        this.customerPhoneNumber = customerPhoneNumber;
        return this;
      }

      /** Job address as newline (Unix) separated string */
      @com.google.api.client.util.Key
      private String address;

      /** Job address as newline (Unix) separated string
       */
      public String getAddress() {
        return address;
      }

      /** Job address as newline (Unix) separated string */
      public Update setAddress(String address) {
        this.address = address;
        return this;
      }

      /** The latitude coordinate of this job's location. */
      @com.google.api.client.util.Key
      private Double lat;

      /** The latitude coordinate of this job's location.
       */
      public Double getLat() {
        return lat;
      }

      /** The latitude coordinate of this job's location. */
      public Update setLat(Double lat) {
        this.lat = lat;
        return this;
      }

      /** Job progress */
      @com.google.api.client.util.Key
      private String progress;

      /** Job progress
       */
      public String getProgress() {
        return progress;
      }

      /** Job progress */
      public Update setProgress(String progress) {
        this.progress = progress;
        return this;
      }

      /** The longitude coordinate of this job's location. */
      @com.google.api.client.util.Key
      private Double lng;

      /** The longitude coordinate of this job's location.
       */
      public Double getLng() {
        return lng;
      }

      /** The longitude coordinate of this job's location. */
      public Update setLng(Double lng) {
        this.lng = lng;
        return this;
      }

      /**
     * Map from custom field id (from /team//custom_fields) to the field value. For example
     * '123=Alice'
     */
      @com.google.api.client.util.Key
      private java.util.List<String> customField;

      /** Map from custom field id (from /team//custom_fields) to the field value. For example '123=Alice'
       */
      public java.util.List<String> getCustomField() {
        return customField;
      }

      /**
     * Map from custom field id (from /team//custom_fields) to the field value. For example
     * '123=Alice'
     */
      public Update setCustomField(java.util.List<String> customField) {
        this.customField = customField;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Location collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Coordinate coordinate = new Coordinate(...);}
   *   {@code Coordinate.Location.List request = coordinate.location().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Location location() {
    return new Location();
  }

  /**
   * The "location" collection of methods.
   */
  public class Location {

    /**
     * Retrieves a list of locations for a worker.
     *
     * Create a request for the method "location.list".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @param workerEmail Worker email address.
     * @param startTimestampMs Start timestamp in milliseconds since the epoch.
     * @return the request
     */
    public List list(String teamId, String workerEmail, UnsignedLong startTimestampMs) throws java.io.IOException {
      List result = new List(teamId, workerEmail, startTimestampMs);
      initialize(result);
      return result;
    }

    public class List extends CoordinateRequest<com.google.api.services.coordinate.model.LocationListResponse> {

      private static final String REST_PATH = "{teamId}/workers/{workerEmail}/locations";

      /**
       * Retrieves a list of locations for a worker.
       *
       * Create a request for the method "location.list".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link List#execute()} method to invoke the remote operation. <p>
       * {@link List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @param workerEmail Worker email address.
       * @param startTimestampMs Start timestamp in milliseconds since the epoch.
       * @since 1.13
       */
      protected List(String teamId, String workerEmail, UnsignedLong startTimestampMs) {
        super(Coordinate.this, "GET", REST_PATH, null, com.google.api.services.coordinate.model.LocationListResponse.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
        this.workerEmail = Preconditions.checkNotNull(workerEmail, "Required parameter workerEmail must be specified.");
        this.startTimestampMs = Preconditions.checkNotNull(startTimestampMs, "Required parameter startTimestampMs must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public List setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

      /** Worker email address. */
      @com.google.api.client.util.Key
      private String workerEmail;

      /** Worker email address.
       */
      public String getWorkerEmail() {
        return workerEmail;
      }

      /** Worker email address. */
      public List setWorkerEmail(String workerEmail) {
        this.workerEmail = workerEmail;
        return this;
      }

      /** Start timestamp in milliseconds since the epoch. */
      @com.google.api.client.util.Key
      private UnsignedLong startTimestampMs;

      /** Start timestamp in milliseconds since the epoch.
       */
      public UnsignedLong getStartTimestampMs() {
        return startTimestampMs;
      }

      /** Start timestamp in milliseconds since the epoch. */
      public List setStartTimestampMs(UnsignedLong startTimestampMs) {
        this.startTimestampMs = startTimestampMs;
        return this;
      }

      /** Continuation token */
      @com.google.api.client.util.Key
      private String pageToken;

      /** Continuation token
       */
      public String getPageToken() {
        return pageToken;
      }

      /** Continuation token */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** Maximum number of results to return in one page. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** Maximum number of results to return in one page.
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** Maximum number of results to return in one page. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Schedule collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Coordinate coordinate = new Coordinate(...);}
   *   {@code Coordinate.Schedule.List request = coordinate.schedule().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Schedule schedule() {
    return new Schedule();
  }

  /**
   * The "schedule" collection of methods.
   */
  public class Schedule {

    /**
     * Retrieves the schedule for a job.
     *
     * Create a request for the method "schedule.get".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @param jobId Job number
     * @return the request
     */
    public Get get(String teamId, UnsignedLong jobId) throws java.io.IOException {
      Get result = new Get(teamId, jobId);
      initialize(result);
      return result;
    }

    public class Get extends CoordinateRequest<com.google.api.services.coordinate.model.Schedule> {

      private static final String REST_PATH = "{teamId}/jobs/{jobId}/schedule";

      /**
       * Retrieves the schedule for a job.
       *
       * Create a request for the method "schedule.get".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link Get#execute()} method to invoke the remote operation. <p>
       * {@link Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @param jobId Job number
       * @since 1.13
       */
      protected Get(String teamId, UnsignedLong jobId) {
        super(Coordinate.this, "GET", REST_PATH, null, com.google.api.services.coordinate.model.Schedule.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
        this.jobId = Preconditions.checkNotNull(jobId, "Required parameter jobId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public Get setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

      /** Job number */
      @com.google.api.client.util.Key
      private UnsignedLong jobId;

      /** Job number
       */
      public UnsignedLong getJobId() {
        return jobId;
      }

      /** Job number */
      public Get setJobId(UnsignedLong jobId) {
        this.jobId = jobId;
        return this;
      }

    }
    /**
     * Replaces the schedule of a job with the provided schedule. This method supports patch semantics.
     *
     * Create a request for the method "schedule.patch".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link Patch#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @param jobId Job number
     * @param content the {@link com.google.api.services.coordinate.model.Schedule}
     * @return the request
     */
    public Patch patch(String teamId, UnsignedLong jobId, com.google.api.services.coordinate.model.Schedule content) throws java.io.IOException {
      Patch result = new Patch(teamId, jobId, content);
      initialize(result);
      return result;
    }

    public class Patch extends CoordinateRequest<com.google.api.services.coordinate.model.Schedule> {

      private static final String REST_PATH = "{teamId}/jobs/{jobId}/schedule";

      /**
       * Replaces the schedule of a job with the provided schedule. This method supports patch
       * semantics.
       *
       * Create a request for the method "schedule.patch".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link Patch#execute()} method to invoke the remote operation.
       * <p> {@link Patch#initialize(AbstractGoogleClientRequest)} must be called to initialize this
       * instance immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @param jobId Job number
       * @param content the {@link com.google.api.services.coordinate.model.Schedule}
       * @since 1.13
       */
      protected Patch(String teamId, UnsignedLong jobId, com.google.api.services.coordinate.model.Schedule content) {
        super(Coordinate.this, "PATCH", REST_PATH, content, com.google.api.services.coordinate.model.Schedule.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
        this.jobId = Preconditions.checkNotNull(jobId, "Required parameter jobId must be specified.");
      }

      @Override
      public Patch setAlt(String alt) {
        return (Patch) super.setAlt(alt);
      }

      @Override
      public Patch setFields(String fields) {
        return (Patch) super.setFields(fields);
      }

      @Override
      public Patch setKey(String key) {
        return (Patch) super.setKey(key);
      }

      @Override
      public Patch setOauthToken(String oauthToken) {
        return (Patch) super.setOauthToken(oauthToken);
      }

      @Override
      public Patch setPrettyPrint(Boolean prettyPrint) {
        return (Patch) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Patch setQuotaUser(String quotaUser) {
        return (Patch) super.setQuotaUser(quotaUser);
      }

      @Override
      public Patch setUserIp(String userIp) {
        return (Patch) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public Patch setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

      /** Job number */
      @com.google.api.client.util.Key
      private UnsignedLong jobId;

      /** Job number
       */
      public UnsignedLong getJobId() {
        return jobId;
      }

      /** Job number */
      public Patch setJobId(UnsignedLong jobId) {
        this.jobId = jobId;
        return this;
      }

      /**
     * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
     * this is true.
     */
      @com.google.api.client.util.Key
      private Boolean allDay;

      /** Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if this
     is true.
       */
      public Boolean getAllDay() {
        return allDay;
      }

      /**
     * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
     * this is true.
     */
      public Patch setAllDay(Boolean allDay) {
        this.allDay = allDay;
        return this;
      }

      /** Scheduled start time in milliseconds since epoch. */
      @com.google.api.client.util.Key
      private UnsignedLong startTime;

      /** Scheduled start time in milliseconds since epoch.
       */
      public UnsignedLong getStartTime() {
        return startTime;
      }

      /** Scheduled start time in milliseconds since epoch. */
      public Patch setStartTime(UnsignedLong startTime) {
        this.startTime = startTime;
        return this;
      }

      /** Job duration in milliseconds. */
      @com.google.api.client.util.Key
      private UnsignedLong duration;

      /** Job duration in milliseconds.
       */
      public UnsignedLong getDuration() {
        return duration;
      }

      /** Job duration in milliseconds. */
      public Patch setDuration(UnsignedLong duration) {
        this.duration = duration;
        return this;
      }

      /** Scheduled end time in milliseconds since epoch. */
      @com.google.api.client.util.Key
      private UnsignedLong endTime;

      /** Scheduled end time in milliseconds since epoch.
       */
      public UnsignedLong getEndTime() {
        return endTime;
      }

      /** Scheduled end time in milliseconds since epoch. */
      public Patch setEndTime(UnsignedLong endTime) {
        this.endTime = endTime;
        return this;
      }

    }
    /**
     * Replaces the schedule of a job with the provided schedule.
     *
     * Create a request for the method "schedule.update".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link Update#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @param jobId Job number
     * @param content the {@link com.google.api.services.coordinate.model.Schedule}
     * @return the request
     */
    public Update update(String teamId, UnsignedLong jobId, com.google.api.services.coordinate.model.Schedule content) throws java.io.IOException {
      Update result = new Update(teamId, jobId, content);
      initialize(result);
      return result;
    }

    public class Update extends CoordinateRequest<com.google.api.services.coordinate.model.Schedule> {

      private static final String REST_PATH = "{teamId}/jobs/{jobId}/schedule";

      /**
       * Replaces the schedule of a job with the provided schedule.
       *
       * Create a request for the method "schedule.update".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link Update#execute()} method to invoke the remote operation.
       * <p> {@link Update#initialize(AbstractGoogleClientRequest)} must be called to initialize this
       * instance immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @param jobId Job number
       * @param content the {@link com.google.api.services.coordinate.model.Schedule}
       * @since 1.13
       */
      protected Update(String teamId, UnsignedLong jobId, com.google.api.services.coordinate.model.Schedule content) {
        super(Coordinate.this, "PUT", REST_PATH, content, com.google.api.services.coordinate.model.Schedule.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
        this.jobId = Preconditions.checkNotNull(jobId, "Required parameter jobId must be specified.");
      }

      @Override
      public Update setAlt(String alt) {
        return (Update) super.setAlt(alt);
      }

      @Override
      public Update setFields(String fields) {
        return (Update) super.setFields(fields);
      }

      @Override
      public Update setKey(String key) {
        return (Update) super.setKey(key);
      }

      @Override
      public Update setOauthToken(String oauthToken) {
        return (Update) super.setOauthToken(oauthToken);
      }

      @Override
      public Update setPrettyPrint(Boolean prettyPrint) {
        return (Update) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Update setQuotaUser(String quotaUser) {
        return (Update) super.setQuotaUser(quotaUser);
      }

      @Override
      public Update setUserIp(String userIp) {
        return (Update) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public Update setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

      /** Job number */
      @com.google.api.client.util.Key
      private UnsignedLong jobId;

      /** Job number
       */
      public UnsignedLong getJobId() {
        return jobId;
      }

      /** Job number */
      public Update setJobId(UnsignedLong jobId) {
        this.jobId = jobId;
        return this;
      }

      /**
     * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
     * this is true.
     */
      @com.google.api.client.util.Key
      private Boolean allDay;

      /** Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if this
     is true.
       */
      public Boolean getAllDay() {
        return allDay;
      }

      /**
     * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
     * this is true.
     */
      public Update setAllDay(Boolean allDay) {
        this.allDay = allDay;
        return this;
      }

      /** Scheduled start time in milliseconds since epoch. */
      @com.google.api.client.util.Key
      private UnsignedLong startTime;

      /** Scheduled start time in milliseconds since epoch.
       */
      public UnsignedLong getStartTime() {
        return startTime;
      }

      /** Scheduled start time in milliseconds since epoch. */
      public Update setStartTime(UnsignedLong startTime) {
        this.startTime = startTime;
        return this;
      }

      /** Job duration in milliseconds. */
      @com.google.api.client.util.Key
      private UnsignedLong duration;

      /** Job duration in milliseconds.
       */
      public UnsignedLong getDuration() {
        return duration;
      }

      /** Job duration in milliseconds. */
      public Update setDuration(UnsignedLong duration) {
        this.duration = duration;
        return this;
      }

      /** Scheduled end time in milliseconds since epoch. */
      @com.google.api.client.util.Key
      private UnsignedLong endTime;

      /** Scheduled end time in milliseconds since epoch.
       */
      public UnsignedLong getEndTime() {
        return endTime;
      }

      /** Scheduled end time in milliseconds since epoch. */
      public Update setEndTime(UnsignedLong endTime) {
        this.endTime = endTime;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Worker collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Coordinate coordinate = new Coordinate(...);}
   *   {@code Coordinate.Worker.List request = coordinate.worker().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Worker worker() {
    return new Worker();
  }

  /**
   * The "worker" collection of methods.
   */
  public class Worker {

    /**
     * Retrieves a list of workers in a team.
     *
     * Create a request for the method "worker.list".
     *
     * This request holds the parameters needed by the the coordinate server.  After setting any
     * optional parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param teamId Team ID
     * @return the request
     */
    public List list(String teamId) throws java.io.IOException {
      List result = new List(teamId);
      initialize(result);
      return result;
    }

    public class List extends CoordinateRequest<com.google.api.services.coordinate.model.WorkerListResponse> {

      private static final String REST_PATH = "{teamId}/workers";

      /**
       * Retrieves a list of workers in a team.
       *
       * Create a request for the method "worker.list".
       *
       * This request holds the parameters needed by the the coordinate server.  After setting any
       * optional parameters, call the {@link List#execute()} method to invoke the remote operation. <p>
       * {@link List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param teamId Team ID
       * @since 1.13
       */
      protected List(String teamId) {
        super(Coordinate.this, "GET", REST_PATH, null, com.google.api.services.coordinate.model.WorkerListResponse.class);
        this.teamId = Preconditions.checkNotNull(teamId, "Required parameter teamId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** Team ID */
      @com.google.api.client.util.Key
      private String teamId;

      /** Team ID
       */
      public String getTeamId() {
        return teamId;
      }

      /** Team ID */
      public List setTeamId(String teamId) {
        this.teamId = teamId;
        return this;
      }

    }

  }

  /**
   * Builder for {@link Coordinate}.
   *
   * <p>
   * Implementation is not thread-safe.
   * </p>
   *
   * @since 1.3.0
   */
  public static final class Builder extends AbstractGoogleJsonClient.Builder {

    /**
     * Returns an instance of a new builder.
     *
     * @param transport HTTP transport
     * @param jsonFactory JSON factory
     * @param httpRequestInitializer HTTP request initializer or {@code null} for none
     * @since 1.7
     */
    public Builder(HttpTransport transport, JsonFactory jsonFactory,
        HttpRequestInitializer httpRequestInitializer) {
      super(
          transport,
          jsonFactory,
          DEFAULT_ROOT_URL,
          DEFAULT_SERVICE_PATH,
          httpRequestInitializer,
          false);
    }

    /** Builds a new instance of {@link Coordinate}. */
    @Override
    public Coordinate build() {
      return new Coordinate(getTransport(),
          getHttpRequestInitializer(),
          getRootUrl(),
          getServicePath(),
          getObjectParser(),
          getGoogleClientRequestInitializer(),
          getApplicationName(),
          getSuppressPatternChecks());
    }

    @Override
    public Builder setRootUrl(String rootUrl) {
      return (Builder) super.setRootUrl(rootUrl);
    }

    @Override
    public Builder setServicePath(String servicePath) {
      return (Builder) super.setServicePath(servicePath);
    }

    @Override
    public Builder setHttpRequestInitializer(HttpRequestInitializer httpRequestInitializer) {
      return (Builder) super.setHttpRequestInitializer(httpRequestInitializer);
    }

    @Override
    public Builder setApplicationName(String applicationName) {
      return (Builder) super.setApplicationName(applicationName);
    }

    @Override
    public Builder setSuppressPatternChecks(boolean suppressPatternChecks) {
      return (Builder) super.setSuppressPatternChecks(suppressPatternChecks);
    }

    /**
     * Set the {@link CoordinateRequestInitializer}.
     *
     * @since 1.12
     */
    public Builder setCoordinateRequestInitializer(
        CoordinateRequestInitializer coordinateRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(coordinateRequestInitializer);
    }

    @Override
    public Builder setGoogleClientRequestInitializer(
        GoogleClientRequestInitializer googleClientRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(googleClientRequestInitializer);
    }
  }
}
